// fin de course sur voie RC 
#include <SoftRcPulseIn.h>
#include <TinyPinChange.h>
#include <SoftRcPulseOut.h>

SoftRcPulseOut monservo1;  // creation de l'objet servo 1
#define BROCHE_VOIE1  A1
#define fcbas_PIN          4 // fin de course montée 
#define fchaut_PIN          5 // fin de course descente
SoftRcPulseIn ImpulsionVoie1;// creation de l'objet voie 1

/* Constantes pour les broches */
const byte TRIGGER_PIN = 13; // Broche TRIGGER du SR-04
const byte ECHO_PIN = 12;    // Broche ECHO du SR-04
 
/* Constantes pour le timeout */
const unsigned long MEASURE_TIMEOUT = 25000UL; // 25ms = ~8m à 340m/s

/* Vitesse du son dans l'air en mm/us */
const float SOUND_SPEED = 340.0 / 1000;


int MAXvoie1 = 2300; //valeur d'impulsion max
int MINvoie1 = 700; //valeur d'impulsion min
int milieuvoie1 = 1500; //valeur d'impulsion neutre
  
// initialisation
void setup()
{
  ImpulsionVoie1.attache(BROCHE_VOIE1);
  monservo1.attach(3);  // signal de sortie PWM pour piloter le servo ou un variateur
 
  pinMode(fcbas_PIN, INPUT);
    digitalWrite(fcbas_PIN, HIGH);
  pinMode(fchaut_PIN, INPUT);
    digitalWrite(fchaut_PIN, HIGH);

   pinMode(TRIGGER_PIN, OUTPUT);
  digitalWrite(TRIGGER_PIN, LOW); // La broche TRIGGER doit être à LOW au repos
  pinMode(ECHO_PIN, INPUT);
}

//==============================================================================================
void loop()
{
  
  unsigned long lectvoie1 = 1500;
  unsigned long commandetrain = 90;
  int commandevoie1 = 2 ;//variable de commande : 1-rentrer 2-auto 3-sortir
      
  if(ImpulsionVoie1.disponible()) //lecture commande de la radio
            {
              lectvoie1 = ImpulsionVoie1.largeur_us();
              if ( lectvoie1 > (milieuvoie1+100) ) {commandevoie1 = 3; }
              else if ( lectvoie1 < (milieuvoie1-100) ) {commandevoie1 = 1; }
              else { commandevoie1 = 2; }
            } 



if (commandevoie1 == 1)   //commande pour rentrer le train
    {
           if (digitalRead(fchaut_PIN) == LOW) {    // fin de course position haut
                commandetrain = 90;
           } else {
                commandetrain = 180;
           }
    }
    

if (commandevoie1 == 3)   //commande pour sortir le train
    {
          if (digitalRead(fchaut_PIN) == LOW) {    // fin de course position bas
                commandetrain = 90;
           } else {
                commandetrain = 0;
           }
      
    }


if (commandevoie1 == 2)   //train en mode automatique
    {
            /* 1. Lance une mesure de distance en envoyant une impulsion HIGH de 10µs sur la broche TRIGGER */
            digitalWrite(TRIGGER_PIN, HIGH);
            delayMicroseconds(10);
            digitalWrite(TRIGGER_PIN, LOW);
  
            /* 2. Mesure le temps entre l'envoi de l'impulsion ultrasonique et son écho (si il existe) */
            long measure = pulseIn(ECHO_PIN, HIGH, MEASURE_TIMEOUT);

            /* 3. Calcul la distance à partir du temps mesuré */
            float distance_mm = measure / 2.0 * SOUND_SPEED;
            
            
            
            if (distance_mm < 2000) { // 2000 étant la distance en millimètres avec le sol

                    if (digitalRead(fchaut_PIN) == LOW) {    // fin de course position bas
                            commandetrain = 90;
                    } else {
                            commandetrain = 0;
                    }
            } else {
                    if (digitalRead(fchaut_PIN) == LOW) {    // fin de course position haut
                            commandetrain = 90;
                    } else {
                            commandetrain = 180;
                    }
            }
  
      
    }
    

    monservo1.write(commandetrain);
    delay(20);
    SoftRcPulseOut::refresh(1);
}

